// Version 9.1a4Demo - 08.11.2019 20:00 Uhr
// (C) by Tobias Auerswald

import groovy.json.JsonSlurper
def ec40FormaterDate = new java.text.SimpleDateFormat('dd.MM.yyyy')
def ec40TimestampDate = ec40FormaterDate.format(new Date())
def ec40FormaterTime = new java.text.SimpleDateFormat('HH:mm:ss:SSS')
def ec40TimestampTime = ec40FormaterTime.format(new Date())
def ec40ResultFile = new File("//")
def ec40TestCaseName = testRunner.testCase.name
def ec40Semicolon = ";;;;;;;;;"
def ec40CvTypeNodeName = ""
def ec40TestRunStatus = ""
def ec40TestCaseStatus = ""

ec40ResultFile << "Testset:;" + ec40TestCaseName + ";"
ec40ResultFile << ("\r\n")
ec40ResultFile << "Date:;" + ec40TimestampDate + ";"
ec40ResultFile << ("\r\n")
ec40ResultFile << "Time:;" + ec40TimestampTime + ";"
ec40ResultFile << ("\r\n")
ec40ResultFile << "User:;" + "SOAP UI Testrunner;"
ec40ResultFile << ("\r\n")
ec40ResultFile << "Name/Steps;Description;Endpoint;Interface;Request;Response;ContentLength;TimeTaken;Result;Result Objekt;Assertions;Expected;Status"
ec40ResultFile << ("\r\n")

def ec60ImportFile = new BufferedReader(new FileReader("//"))
def ec60ErrorMessageValue = "EC60 in SoapUI no custom property is applied for the field name: "
def ec60HeaderFieldNames = ""
def ec60NameHeader = "Active"
def ec60RowActivate = "Ja"
def ec60HeaderApiNamesMap = [:]
def ec60HeaderStepNamesMap = [:]
def ec60HeaderSyncStep2ApiMap = [:]
def ec60HeaderFieldNamesMap = [:]
String[] ec60BlackListFieldName = ["${ec60NameHeader}", "", "Name", "Description"]
def ec60FieldName = ""
def ec60FieldNameParameter = ""

ec60ImportFile.eachLine { ec60LineRecordDataContent ->
	String[] ec60LineRecordData = ec60LineRecordDataContent.split(";")
	if (ec60LineRecordData[0] == "Steps") {
		ec60LineRecordData.eachWithIndex { ec60StepName, ec60StepNameID ->
			if (ec60StepNameID != 0) { 				
			    ec60HeaderStepNamesMap.put(ec60StepNameID, ec60StepName)
			}				
		}
		log.info "ec60HeaderStepNamesMap: " + ec60HeaderStepNamesMap
	}
	if (ec60LineRecordData[0] == "API") {
		ec60LineRecordData.eachWithIndex { ec60ApiName, ec60ApiNameID ->
			if (ec60ApiNameID != 0) { 				
				if (testRunner.getTestCase().getTestStepList().name.contains(ec60ApiName) == false) {
					log.info "API '" + ec60ApiName + "' is unknown"
					return null
				} else {
					ec60HeaderApiNamesMap.put(ec60ApiNameID, ec60ApiName)
					ec60HeaderSyncStep2ApiMap.put(ec60HeaderStepNamesMap.get(ec60ApiNameID), ec60ApiName)
				}			
			}	
		}
		log.info "ec60HeaderApiNamesMap: " + ec60HeaderApiNamesMap
		log.info "ec60HeaderSyncStep2ApiMap: " + ec60HeaderSyncStep2ApiMap
	}
	if (ec60LineRecordData[0] == ec60NameHeader) {
		ec60HeaderFieldNames = ec60LineRecordData
		log.info "ec60HeaderFieldNames: " + ec60HeaderFieldNames
		ec60HeaderFieldNames.eachWithIndex { ec60HeaderFieldName, ec60HeaderFieldNameID ->	
			boolean ec60CheckSetProperty = Arrays.asList(ec60BlackListFieldName).contains(ec60HeaderFieldName)
			if (ec60CheckSetProperty) {
 				log.info ec60ErrorMessageValue + ec60HeaderFieldName
			} else {
				ec60HeaderFieldNamesMap.put(ec60HeaderFieldNameID, ec60HeaderFieldName)
			}
		}
		log.info "ec60HeaderFieldNamesMap: " + ec60HeaderFieldNamesMap
	}
	if (ec60LineRecordData[0] == ec60RowActivate) {
    	log.info "ec60LineRecordData: " + ec60LineRecordData
		ec40TestCaseStatus = ""
		ec40ResultFile << ec60LineRecordData[1] + ";" + ec60LineRecordData[2] + ";"
		ec40ResultFile << ("\r\n")
		ec60LineRecordData.eachWithIndex { ec60CellFeld, ec60CellFeldID ->
			if (ec60HeaderFieldNamesMap.get(ec60CellFeldID) == null) {
				log.info "EC60 " + ec60CellFeld + " is not use"
			} else {
				ec60FieldName = ec60HeaderFieldNamesMap.get(ec60CellFeldID)
				ec60FieldNameParameter = ec60FieldName.split("_")
				def ec60CellFieldParameter = [null, null]
				if (ec60CellFeld.contains("_")) {
					ec60CellFieldParameter = ec60CellFeld.split("_")
				}
				testRunner.testCase.setPropertyValue("Step", ec60FieldNameParameter[0])
				if (ec60FieldNameParameter[1] == "TD") {
					testRunner.testCase.setPropertyValue(ec60FieldName,ec60CellFeld)
				}
				if (ec60FieldNameParameter[1] == "CV") {
					if (ec60CellFeld == "") {
						log.info "EC60 CV empty"
						testRunner.testCase.setPropertyValue("${ec60FieldName}_empty","true")							
					} else {
						ec60CellFeld.split("&&").eachWithIndex { ec60Cv, ec60CvID ->
    						def ec60CvTypeValue = ec60Cv.split(":")
    						log.info "EC60 ${ec60FieldName}_type${ec60CvID+1}: ${ec60CvTypeValue[0]}"
    						log.info "EC60 ${ec60FieldName}_value${ec60CvID+1}: ${ec60CvTypeValue[1]}"
							testRunner.testCase.setPropertyValue("${ec60FieldName}_type${ec60CvID+1}",ec60CvTypeValue[0])
							testRunner.testCase.setPropertyValue("${ec60FieldName}_value${ec60CvID+1}",ec60CvTypeValue[1])							
						}
					}
				}
				if (ec60CellFieldParameter[1] == "GET") {
					testRunner.testCase.setPropertyValue(ec60FieldName,testRunner.testCase.getPropertyValue("${ec60CellFieldParameter[0]}_RE_${ec60CellFieldParameter[2]}"))
				}
				def groovyUtils = new com.eviware.soapui.support.GroovyUtils(context)
				def ec20CvResultValue = ""
				def ec20TestStatus = ""
				def ec20ApiDesign = "JSON"
				def ec20ResultResponceValue = ""
				def ec20NewFieldNameParameter = ""
				def ec20TestStepStatus = "UNKNOWN"
				def ec20ApiName = ""
				def ec20testResponceValue = ""
				if (ec60HeaderFieldNamesMap.get(ec60CellFeldID.plus(1)) != null) {
					ec20NewFieldNameParameter = ec60HeaderFieldNamesMap.get(ec60CellFeldID.plus(1)).split("_")
					
				} else {
					ec20NewFieldNameParameter = ec60FieldNameParameter[0]+1
				}
				if (ec60FieldNameParameter[0] != ec20NewFieldNameParameter[0]) {
					ec20ApiName = ec60HeaderSyncStep2ApiMap.get(ec60FieldNameParameter[0])
					log.info "EC20 start run test for " + ec20ApiName + " / " + ec60FieldNameParameter[0]
					def ec20HeaderFieldNames = ec60HeaderFieldNames.findAll{it.contains(ec60FieldNameParameter[0] + '_TD_')}
					ec20HeaderFieldNames.each {ec20HeaderFieldName ->
					def ec20testStepParameter = ec20HeaderFieldName.split("_")
					def ec20requestValue = testRunner.testCase.getTestStepByName(ec20ApiName).getProperty("Request").value
					if (ec20requestValue != "") {
							def ec20requestValueReplace = ec20requestValue.replace('"' + ec20testStepParameter[2] + '" : ""', '"' + ec20testStepParameter[2] + '" : "${#TestCase#${#TestCase#Step}_TD_' + ec20testStepParameter[2] + '}"')
							testRunner.testCase.getTestStepByName(ec20ApiName).setPropertyValue("Request", ec20requestValueReplace)
						} else {
							testRunner.testCase.getTestStepByName(ec20ApiName).setPropertyValue(ec20testStepParameter[2], '${#TestCase#${#TestCase#Step}_TD_' + ec20testStepParameter[2] + '}')
						}
					}
	 				testRunner.runTestStepByName(ec20ApiName)
					ec20testResponceValue = testRunner.testCase.getTestStepByName(ec20ApiName).getProperty("Response").value
					if (ec20ApiDesign == "XML") {
						def ec20XmlHolder = groovyUtils.getJsonHolder(ec20testResponceValue)
						ec20ResultResponceValue = ec20XmlHolder.getNodeValue("//ns1:*/Result")
					} else if (ec20ApiDesign == "JSON") {
						def ec20JsonSlurper = new JsonSlurper()
						try {
							ec20ResultResponceValue = ec20JsonSlurper.parseText(ec20testResponceValue)
						} catch (e) {
							log.info "EC20 Error - JSON not valid"
    						assert e instanceof IndexOutOfBoundsException
						}
					} else {
						log.info "No support for this API design"
						return null
					}

					def ec20ResponseHeaders = testRunner.testCase.getTestStepByName(ec20ApiName).testRequest.response.responseHeaders
					def ec20HttpStatusCode = (ec20ResponseHeaders["#status#"] =~ "[1-5]\\d\\d")[0]
					log.info("EC20 HTTP status code: " + ec20HttpStatusCode)

					def ec20TestEndpoint = testRunner.testCase.getTestStepByName(ec20ApiName).properties['Endpoint'].value

					def ec20TestRequest = []
					ec20TestRequest.add(testRunner.testCase.getTestStepByName(ec20ApiName).getProperty("rawRequest").value.replaceAll("\\r?\\n", ""))
					if(ec20TestRequest[0] == "") {
						ec20TestRequest.remove(0)
						def propertyEntryName = ""
						for (propertyEntry in testRunner.testCase.getTestStepByName(ec20ApiName).getPropertyList()){
							propertyEntryName = propertyEntry.getName()
							if ((propertyEntryName != "Endpoint") && (propertyEntryName != "Username") && (propertyEntryName != "Password") && (propertyEntryName != "Domain") && (propertyEntryName != "Request") && (propertyEntryName != "ResponseAsXml") && (propertyEntryName != "Response") && (propertyEntryName != "RawRequest")) {
								ec20TestRequest.add(propertyEntryName + " = " + context.expand(testRunner.testCase.getTestStepByName("checkConfig").getProperty(propertyEntryName).getValue()))
							}
						}
					}
					def ec20ContentLength = ec20ResponseHeaders["Content-Length"]
					def ec20TimeTaken =  testRunner.testCase.getTestStepByName(ec20ApiName).testRequest.response.timeTaken

					ec40ResultFile << ec60FieldNameParameter[0] + ";;" + ec20TestEndpoint + ";" + ec20ApiName + ";" + ec20TestRequest + ";" + ec20testResponceValue.replaceAll("\\r?\\n", "") + ";" + ec20ContentLength + ";" + ec20TimeTaken + ";" + ec20ResultResponceValue
					ec40ResultFile << ("\r\n")

					def ec20CvTypeID = 1
					while (testRunner.testCase.getPropertyValue("${ec60FieldNameParameter[0]}_CV_type${ec20CvTypeID}") != null) {
						def ec20CVTypeParameter = ""
						def ec20CvTypeOperator = ""
						def ec20CvTypeNodeName = null
						ec40CvTypeNodeName = ""
						def ec20CvType = "${ec60FieldNameParameter[0]}_CV_type${ec20CvTypeID}"
						ec20CvResultValue = testRunner.testCase.getPropertyValue("${ec60FieldNameParameter[0]}_CV_value${ec20CvTypeID}")

						if (testRunner.testCase.getPropertyValue("${ec60FieldNameParameter[0]}_CV_type${ec20CvTypeID}").contains("==") == true) {
							ec20CVTypeParameter = testRunner.testCase.getPropertyValue("${ec60FieldNameParameter[0]}_CV_type${ec20CvTypeID}").split("==")
							ec20CvTypeNodeName = ec20CVTypeParameter[0]
							ec20CvTypeOperator = ec20CVTypeParameter[1]
							ec40CvTypeNodeName = ec20CVTypeParameter[0]
						} else {
							ec20CvTypeOperator =  testRunner.testCase.getPropertyValue("${ec60FieldNameParameter[0]}_CV_type${ec20CvTypeID}")
						}

						switch (ec20CvTypeOperator) {
							case "validHTTP": 
							if (ec20HttpStatusCode == ec20CvResultValue) {
								ec20TestStatus = "PASSED"
							} else {
								ec20TestStatus = "FAILED"
							}
							break 

         					case "contains":
							if (ec20CvTypeNodeName != null) {
								testRunner.testCase.setPropertyValue("${ec60FieldNameParameter[0]}_RE_${ec20CvTypeNodeName}", ec20ResultResponceValue.get(ec20CvTypeNodeName))
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName).contains(ec20CvResultValue) == true) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}						
							} else {
								if (ec20testResponceValue.contains(ec20CvResultValue) == true) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}
							}
							break

							case "notContains":
							 if (ec20CvTypeNodeName != null) {
								testRunner.testCase.setPropertyValue("${ec60FieldNameParameter[0]}_RE_${ec20CvTypeNodeName}", ec20ResultResponceValue.get(ec20CvTypeNodeName))
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName).contains(ec20CvResultValue) == false) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}						
							} else {
								if (ec20testResponceValue.contains(ec20CvResultValue) == false) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}
							}
							break

							case "equal":
							if (ec20CvTypeNodeName != null) {
								testRunner.testCase.setPropertyValue("${ec60FieldNameParameter[0]}_RE_${ec20CvTypeNodeName}", ec20ResultResponceValue.get(ec20CvTypeNodeName))
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) == ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}						
							} else {
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) == ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}
							}
							break

							case "different":
							if (ec20CvTypeNodeName != null) {
								testRunner.testCase.setPropertyValue("${ec60FieldNameParameter[0]}_RE_${ec20CvTypeNodeName}", ec20ResultResponceValue.get(ec20CvTypeNodeName))
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) != ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}						
							} else {
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) != ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}
							}
							break

							case "less":
							 if (ec20CvTypeNodeName != null) {
								testRunner.testCase.setPropertyValue("${ec60FieldNameParameter[0]}_RE_${ec20CvTypeNodeName}", ec20ResultResponceValue.get(ec20CvTypeNodeName))
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) < ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}						
							} else {
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) < ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}
							}
							break

							case "greater":
							 if (ec20CvTypeNodeName != null) {
								testRunner.testCase.setPropertyValue("${ec60FieldNameParameter[0]}_RE_${ec20CvTypeNodeName}", ec20ResultResponceValue.get(ec20CvTypeNodeName))
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) > ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}						
							} else {
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) > ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}
							}
							break

							case "lessEqual":
							 if (ec20CvTypeNodeName != null) {
								testRunner.testCase.setPropertyValue("${ec60FieldNameParameter[0]}_RE_${ec20CvTypeNodeName}", ec20ResultResponceValue.get(ec20CvTypeNodeName))
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) <= ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}						
							} else {
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) <= ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}
							}
							break

							case "greaterEqual":
							 if (ec20CvTypeNodeName != null) {
								testRunner.testCase.setPropertyValue("${ec60FieldNameParameter[0]}_RE_${ec20CvTypeNodeName}", ec20ResultResponceValue.get(ec20CvTypeNodeName))
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) >= ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}						
							} else {
								if (ec20ResultResponceValue.get(ec20CvTypeNodeName) >= ec20CvResultValue) {
									ec20TestStatus = "PASSED"
								} else {
									ec20TestStatus = "FAILED"
								}
							}
							break
            		
         					default: 
							log.info "EC20 Check value not possible!"
							break
						}
						if (ec20TestStatus == "PASSED") {
							if (ec20TestStepStatus != "FAILED") {
								ec20TestStepStatus = "PASSED"
								testRunner.testCase.getTestStepByName(ec20ApiName).assertionStatus.toString() == "PASSED"
								testRunner.testCase.testSteps[ec20ApiName].addAssertion("PASSED")
							}
							if (ec40TestRunStatus != "FAILED") {
								ec40TestRunStatus = "PASSED"
							}
							if (ec40TestCaseStatus != "FAILED") {
								ec40TestCaseStatus = "PASSED"
							}
						} else {
							ec20TestStepStatus = "FAILED"
							ec40TestRunStatus = "FAILED"
							ec40TestCaseStatus = "FAILED"
							testRunner.testCase.getTestStepByName(ec20ApiName).assertionStatus.toString() == "FAILED"
						}
						log.info "EC20 " + ec20CvType + " " + ec20TestStatus
						ec40ResultFile << ec40Semicolon + ec40CvTypeNodeName + ";" + ec20CvTypeOperator + ";" + ec20CvResultValue + ";" + ec20TestStatus
						ec40ResultFile << ("\r\n")
						ec20CvTypeID++	
					}
					ec20testResponceValue.each {
						def ec20formater = new java.text.SimpleDateFormat('yyyy-MM-dd_HH-mm-ss')
						def ec20timestamp = ec20formater.format(new Date())
						def ec20InputFileRequest = new File("\\Logs\\" + ec20timestamp  + "-" + ec60FieldNameParameter[0] + "-" + ec20ApiName + "-" + ec20TestStepStatus + "-" + "Request" + ".txt")
						ec20InputFileRequest.write(testRunner.testCase.getTestStepByName(ec20ApiName).getProperty("rawRequest").value)
						def ec20InputFileResponse = new File("\\Logs\\" + ec20timestamp  + "-" + ec60FieldNameParameter[0] + "-" + ec20ApiName + "-" + ec20TestStepStatus + "-" + "Response" + ".txt")
						ec20InputFileResponse.write(ec20testResponceValue)
					}
					log.info "EC20 end run test for " + ec20ApiName + " / " + ec60FieldNameParameter[0]
				}
			}
		}
		ec40ResultFile << ec40Semicolon + ";;Status Testfall: ; " + ec40TestCaseStatus
		ec40ResultFile << ("\r\n")
		for (prop in context.testCase.properties) {
		 context.testCase.removeProperty( prop.value.name )
		}
	}	
}
ec40ResultFile << ec40Semicolon + ";;Testcase status: ; " + ec40TestRunStatus 
ec40ResultFile << ("\r\n")
ec40ResultFile << ("\r\n")
ec40ResultFile << ("'--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------")
ec40ResultFile << ("\r\n")
ec40ResultFile << ("\r\n")
